Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang.reflect
Class Constructor

    java.lang.Object
      |
      +--java.lang.reflect.AccessibleObject
            |
            +--java.lang.reflect.Constructor

All Implemented Interfaces:
  Member

public final class Constructor
extends AccessibleObject
implements Member

`Constructor` provides information about, and access to, a single constructor for a class.

`Constructor` permits widening conversions to occur when matching the actual parameters to newInstance() with the underlying constructor's formal parameters, but throws an `IllegalArgumentException` if a narrowing conversion would occur.

See Also:
  `Member`, `Class`, `Class.getConstructors()`, `Class.getConstructor(Class[])`, `Class.getDeclaredConstructors()`

Fields inherited from interface java.lang.reflect.Member
`DECLARED, PUBLIC`

Method Summary
`boolean` | `equals(Object obj)` Compares this `Constructor` against the specified object.
`Class` | `getDeclaringClass()` Returns the `Class` object representing the class that declares the constructor represented by this `Constructor` object.
`Class[]` | `getExceptionTypes()` Returns an array of `Class` objects that represent the types of of exceptions declared to be thrown by the underlying constructor represented by this `Constructor` object.
`int` | `getModifiers()` Returns the Java language modifiers for the constructor represented by this `Constructor` object, as an integer.
`String` | `getName()` Returns the name of this constructor, as a string.
`Class[]` | `getParameterTypes()` Returns an array of `Class` objects that represent the formal parameter types, in declaration order, of the constructor represented by this `Constructor` object.
`int` | `hashCode()` Returns a hashcode for this `Constructor`.
`Object` | `newInstance(Object[] initargs)` Uses the constructor represented by this `Constructor` object to create and initialize a new instance of the constructor's declaring class, with the specified initialization parameters.
`String` | `toString()` Returns a string describing this `Constructor`.

Methods inherited from class java.lang.reflect.AccessibleObject
`isAccessible, setAccessible, setAccessible`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### getDeclaringClass

    public Class getDeclaringClass()

  Returns the `Class` object representing the class that declares the constructor represented by this `Constructor` object.
  Specified by:
    `getDeclaringClass` in interface `Member`

### getName

    public String getName()

  Returns the name of this constructor, as a string. This is always the same as the simple name of the constructor's declaring class.
  Specified by:
    `getName` in interface `Member`

### getModifiers

    public int getModifiers()

  Returns the Java language modifiers for the constructor represented by this `Constructor` object, as an integer. The `Modifier` class should be used to decode the modifiers.
  Specified by:
    `getModifiers` in interface `Member`
  See Also:
    `Modifier`

### getParameterTypes

    public Class[] getParameterTypes()

  Returns an array of `Class` objects that represent the formal parameter types, in declaration order, of the constructor represented by this `Constructor` object. Returns an array of length 0 if the underlying constructor takes no parameters.

### getExceptionTypes

    public Class[] getExceptionTypes()

  Returns an array of `Class` objects that represent the types of of exceptions declared to be thrown by the underlying constructor represented by this `Constructor` object. Returns an array of length 0 if the constructor declares no exceptions in its `throws` clause.

### equals

    public boolean equals(Object obj)

  Compares this `Constructor` against the specified object. Returns true if the objects are the same. Two `Constructor` objects are the same if they were declared by the same class and have the same formal parameter types.
  Overrides:
    `equals` in class `Object`
  Following copied from class: `java.lang.Object`
  Parameters:
    `obj` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Boolean.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns a hashcode for this `Constructor`. The hashcode is the same as the hashcode for the underlying constructor's declaring class name.
  Overrides:
    `hashCode` in class `Object`
  Following copied from class: `java.lang.Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Returns a string describing this `Constructor`. The string is formatted as the constructor access modifiers, if any, followed by the fully-qualified name of the declaring class, followed by a parenthesized, comma-separated list of the constructor's formal parameter types. For example:

          public java.util.Hashtable(int,float)

  The only possible modifiers for constructors are the access modifiers `public`, `protected` or `private`. Only one of these may appear, or none if the constructor has default (package) access.

  Overrides:
    `toString` in class `Object`
  Following copied from class: `java.lang.Object`
  Returns:
    a string representation of the object.

### newInstance

    public Object newInstance(Object[] initargs)
                       throws InstantiationException,
                              IllegalAccessException,
                              IllegalArgumentException,
                              InvocationTargetException

  Uses the constructor represented by this `Constructor` object to create and initialize a new instance of the constructor's declaring class, with the specified initialization parameters. Individual parameters are automatically unwrapped to match primitive formal parameters, and both primitive and reference parameters are subject to method invocation conversions as necessary. Returns the newly created and initialized object.

  Creation proceeds with the following steps, in order:

  If the class that declares the underlying constructor represents an abstract class, the creation throws an `InstantiationException`.

  If this `Constructor` object enforces Java language access control and the underlying constructor is inaccessible, the creation throws an `IllegalAccessException`.

  If the number of actual parameters supplied via `initargs` is different from the number of formal parameters required by the underlying constructor, the creation throws an `IllegalArgumentException`.

  A new instance of the constructor's declaring class is created, and its fields are initialized to their default initial values.

  For each actual parameter in the supplied `initargs` array:

  If the corresponding formal parameter has a primitive type, an unwrapping conversion is attempted to convert the object value to a value of the primitive type. If this attempt fails, the creation throws an `IllegalArgumentException`.

  If, after possible unwrapping, the parameter value cannot be converted to the corresponding formal parameter type by a method invocation conversion, the creation throws an `IllegalArgumentException`.

  The constructor's declaring class is initialized if it has not already been initialized. A new instance of the constructor's declaring class is created, and its fields are initialized to their default initial values.

  Control transfers to the underlying constructor to initialize the new instance. If the constructor completes abruptly by throwing an exception, the exception is placed in an `InvocationTargetException` and thrown in turn to the caller of `newInstance`.

  If the constructor completes normally, returns the newly created and initialized instance.

  Throws:
    `IllegalAccessException` - if the underlying constructor is inaccessible.
    `IllegalArgumentException` - if the number of actual and formal parameters differ, or if an unwrapping or method invocation conversion fails.
    `InstantiationException` - if the class that declares the underlying constructor represents an abstract class.
    `InvocationTargetException` - if the underlying constructor throws an exception.
    `ExceptionInInitializerError` - if the initialization provoked by this method fails.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >